

#
# datei einlesen ... alle durchgehen ... entry fuer jeden ... onchange write




variable V
variable Cfg

set Cfg(ui) 2
set Cfg(fn) "../val.txt"
set Cfg(incrfn) "../backup/val"
set Cfg(missingfn) "keys.txt"


proc readfile {} {
	global V
	global Cfg

	set fn $Cfg(fn)
	set f [open $fn "r"]

	while {![eof $f]} {
		#puts [gets $f]
		set l [gets $f]

		set a [split $l "="]
		set key [lindex $a 0]
		set val [lindex $a 1]
		#puts "$key $val"

		set V($key) $val
	}

	close $f
}

proc ui_int { n root} {
	global V
	global Cfg
	#frame $root.$n
	#set myroot $root.$n
	set myroot $root
	set c $Cfg(counter)

	label $myroot.l$c -text $n -anchor w
	button $myroot.m$c -text "-" -command "tw_int_change $n -1"
	button $myroot.p$c -text "+" -command "tw_int_change $n +1"
	entry $myroot.e$c -textvariable V($n)
	#pack $myroot.l -side left
	#pack $myroot.m -side left
	#pack $myroot.p -side left
	#pack $myroot.e -side right

	grid $myroot.l$c -column 1 -row $c
	grid $myroot.p$c -column 2 -row $c
	grid $myroot.m$c -column 3 -row $c
	grid $myroot.e$c -column 4 -row $c
	incr Cfg(counter) 1

	#pack $myroot -side top
}
proc tw_int_change { name dir } {
	global V
	set v $V($name)
	set v [ expr $v + $dir ]
	set V($name) $v
	submit
}

proc ui_float { n root} {
	global V
	global Cfg
	#frame $root.$n

	set myroot $root
	set c $Cfg(counter)

	entry $myroot.e$c -textvariable V($n)
	label $myroot.l$c -text $n -anchor w
	button $myroot.m$c -text "-" -command "tw_float_change $n -1"
	button $myroot.p$c -text "+" -command "tw_float_change $n +1"

	grid $myroot.l$c -column 1 -row $c
	grid $myroot.p$c -column 2 -row $c
	grid $myroot.m$c -column 3 -row $c
	grid $myroot.e$c -column 4 -row $c
	incr Cfg(counter) 1
}



proc tw_float_change { name dir } {
	global V
	set v $V($name)
	set v [ expr $v + 0.1*$dir ]
	set V($name) $v
	submit
}

proc ui_color { n root} {
	global V
	global Cfg
	#frame $root.w$n
	set myroot $root
	set c $Cfg(counter)

	#entry .$n.e -textvariable V($n)
	label $myroot.l$c -text $n -anchor w
	button $myroot.b$c -command "tw_color_change $n $root $c" -bg [rgbtohex $V($n)]

	grid $myroot.l$c -column 1 -row $c
	grid $myroot.b$c -column 4 -row $c
	incr Cfg(counter) 1
	#button .$n.m -text "-" -command "tw_float_change $n -1"
	#button .$n.p -text "+" -command "tw_float_change $n +1"
	#pack $root.l -side left
	#pack $root.b -side right
	#pack $root -side top
}
proc ui_color_updatebutton { n root num} {
	global V
	#$root.w$n.b configure -bg [rgbtohex $V($n)]
	$root.b$num configure -bg [rgbtohex $V($n)]
}

proc hextorgb {hex } {
	scan $hex "\#%2x%2x%2x" red green blue
	return "$red,$green,$blue"
}

proc rgbtohex { rgb } {
	if {$rgb==""} { return "#000000"; }
	set a [split $rgb ","]
	set red [lindex $a 0]
	set green [lindex $a 1]
	set blue [lindex $a 2]
	set rgb \#[format "%.2X%.2X%.2X" $red $green $blue]
}

proc tw_color_change { name root num} {
	global V
	set ini [rgbtohex $V($name)]
	set col [tk_chooseColor -initialcolor $ini -title "Choose color"]

	#set r 5
	#set g 5
	#set b 5
	#set cn "$r,$g,$b"
	set cn [hextorgb $col]

	set V($name) $cn
	ui_color_updatebutton $name $root $num

	#puts "$name $V($name)"
	submit
}

proc ui_c3 { n root} {
	global V
	global Cfg
	#frame $root.$n

	set myroot $root
	set c $Cfg(counter)

	entry $myroot.e$c -textvariable V($n)
	label $myroot.l$c -text $n -anchor w
	button $myroot.m$c -text "-" -command ""
	button $myroot.p$c -text "+" -command ""

	grid $myroot.l$c -column 1 -row $c
	grid $myroot.p$c -column 2 -row $c
	grid $myroot.m$c -column 3 -row $c
	grid $myroot.e$c -column 4 -row $c
	incr Cfg(counter) 1
}

proc ui_c3f { n root} {
	global V
	global Cfg
	#frame $root.$n

	set myroot $root
	set c $Cfg(counter)

	entry $myroot.e$c -textvariable V($n)
	label $myroot.l$c -text $n -anchor w
	button $myroot.m$c -text "-" -command ""
	button $myroot.p$c -text "+" -command ""

	grid $myroot.l$c -column 1 -row $c
	grid $myroot.p$c -column 2 -row $c
	grid $myroot.m$c -column 3 -row $c
	grid $myroot.e$c -column 4 -row $c
	incr Cfg(counter) 1
}



proc genui {} {
	frame .buttons
	button .buttons.submit -text "submit" -command "submit"
	button .buttons.backup -text "backup" -command "save_incr"
	button .buttons.miss -text "add" -command "checkmissing"
	#pack .buttons.submit -side left
	#pack .buttons.backup 
	#pack .buttons.miss -side right
	#pack .buttons

	grid .buttons.submit .buttons.backup .buttons.miss

	pack .buttons -padx 15
	gensubui
}
proc afterunderscore {s} {
	set start [string first "_" $s]
	incr start 1
	set r [ string range $s $start [string length $s]]
	return $r
}
proc compareafterunderscore { a b } {
	return [ string compare [afterunderscore $a] [afterunderscore $b] ]
}
proc underscore {str first last} {
   set a [split $str "_"]
   set r [join [lrange $a $first $last] "_"]
}

proc gensubui {} {
	global Cfg
	global V

	set Cfg(counter) 0

	#puts "gensubui"
	if ($Cfg(ui)==2) {
		iwidgets::scrolledframe .sub -width 350 -height 700 -vscrollmode static -hscrollmode dynamic -borderwidth 1

		set root [.sub childsite]
		#puts "2  $root "
		#frame $root.l
		#frame $root.r
	} else {
		frame .sub
		set root ".sub"
		#frame $root.l
		#frame $root.r
	}

	foreach n [lsort [array names V]] {
		if { $n=="" } continue;
		set v V($n)

		#set t [string range $n 0 0]
		set t [underscore $n end end]
		puts "gensubui $n $v t: ($t)"
		

		if { $t=="f" } { ui_float $n $root}
		if { $t=="i" } { ui_int $n $root}
		if { $t=="color" } { ui_color $n $root}
		if { $t=="C3" } { ui_c3 $n $root}
		if { $t=="C3f" } { ui_c3f $n $root}
	}
	pack .sub -expand 1 -fill both

}

proc save_incr {} {
	global V
	global Cfg

	global V
	global Cfg

	set t [clock seconds]
	set fn "$Cfg(incrfn)_$t"
	#puts "save incr $fn"
	set f [open $fn "w"]

	foreach {n v} [array get V] {
		#puts "$n $v"
		if { $n=="" } continue;
		puts $f "$n=$V($n)"
	}
	close $f
}

proc submit {} {
	global V
	global Cfg

	#puts "submit"
	global V
	global Cfg

	set fn $Cfg(fn)
	set f [open $fn "w"]

	foreach n [lsort [array names V]] {
		if { $n=="" } continue;
		set v V($n)
		#puts "$n $v"
		if { $n=="" } continue;
		puts $f "$n=$V($n)"
	}
	close $f
}

proc checkmissing {} {
	global V
	global Cfg


	set fn $Cfg(missingfn)

	set f [open $fn "r"]

	#if {!$f} return;

	set added 0
	while {![eof $f]} {
		set l [gets $f]
		if { $l=="" } continue
		#puts "l: $l"

		if {[array names V $l]!=""	} continue;
		set V($l) ""
		set added 1
	}
	close $f

	if {$added==0} return;
	pack forget .sub
	destroy .sub

	gensubui
}

if ($Cfg(ui)==2) {
	package require Itcl
	package require Iwidgets
}

readfile

genui

